# coding: utf-8

"""
    ****************************************************************************
    Copyright (c) 2016-present,
    Jaguar0625, gimre, BloodyRookie, Tech Bureau, Corp. All rights reserved.

    This file is part of Catapult.

    Catapult is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Catapult is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Catapult. If not, see <http://www.gnu.org/licenses/>.
    ****************************************************************************
    
    Catapult REST Endpoints
    OpenAPI Specification of catapult-rest 2.2.0  # noqa: E501
    The version of the OpenAPI document: 0.10.4
    Contact: contact@nem.foundation

    NOTE: This file is auto generated by Symbol OpenAPI Generator:
    https://github.com/nemtech/symbol-openapi-generator
    Do not edit this file manually.
"""


import pprint
import re  # noqa: F401

import six

from symbol_openapi_client.configuration import Configuration


class CommunicationTimestampsDTO(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'send_timestamp': 'str',
        'receive_timestamp': 'str'
    }

    attribute_map = {
        'send_timestamp': 'sendTimestamp',
        'receive_timestamp': 'receiveTimestamp'
    }

    def __init__(self, send_timestamp=None, receive_timestamp=None, local_vars_configuration=None):  # noqa: E501
        """CommunicationTimestampsDTO - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._send_timestamp = None
        self._receive_timestamp = None
        self.discriminator = None

        if send_timestamp is not None:
            self.send_timestamp = send_timestamp
        if receive_timestamp is not None:
            self.receive_timestamp = receive_timestamp

    @property
    def send_timestamp(self):
        """Gets the send_timestamp of this CommunicationTimestampsDTO.  # noqa: E501

        Number of seconds elapsed since the creation of the nemesis block.  # noqa: E501

        :return: The send_timestamp of this CommunicationTimestampsDTO.  # noqa: E501
        :rtype: str
        """
        return self._send_timestamp

    @send_timestamp.setter
    def send_timestamp(self, send_timestamp):
        """Sets the send_timestamp of this CommunicationTimestampsDTO.

        Number of seconds elapsed since the creation of the nemesis block.  # noqa: E501

        :param send_timestamp: The send_timestamp of this CommunicationTimestampsDTO.  # noqa: E501
        :type: str
        """

        self._send_timestamp = send_timestamp

    @property
    def receive_timestamp(self):
        """Gets the receive_timestamp of this CommunicationTimestampsDTO.  # noqa: E501

        Number of seconds elapsed since the creation of the nemesis block.  # noqa: E501

        :return: The receive_timestamp of this CommunicationTimestampsDTO.  # noqa: E501
        :rtype: str
        """
        return self._receive_timestamp

    @receive_timestamp.setter
    def receive_timestamp(self, receive_timestamp):
        """Sets the receive_timestamp of this CommunicationTimestampsDTO.

        Number of seconds elapsed since the creation of the nemesis block.  # noqa: E501

        :param receive_timestamp: The receive_timestamp of this CommunicationTimestampsDTO.  # noqa: E501
        :type: str
        """

        self._receive_timestamp = receive_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommunicationTimestampsDTO):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CommunicationTimestampsDTO):
            return True

        return self.to_dict() != other.to_dict()
